## libretro-bsnes-mercury 094%2Bgit20220807

=== gb/Makefile ===
gb_objects := gb-interface gb-system gb-scheduler
gb_objects += gb-memory gb-cartridge
gb_objects += gb-cpu gb-ppu gb-apu
gb_objects += gb-cheat gb-video
objects += $(gb_objects)

obj/gb-interface.o: $(gb)/interface/interface.cpp $(call rwildcard,$(gb)/interface/)
obj/gb-system.o:    $(gb)/system/system.cpp $(call rwildcard,$(gb)/system/)
obj/gb-scheduler.o: $(gb)/scheduler/scheduler.cpp $(call rwildcard,$(gb)/scheduler/)
obj/gb-cartridge.o: $(gb)/cartridge/cartridge.cpp $(call rwildcard,$(gb)/cartridge/)
obj/gb-memory.o:    $(gb)/memory/memory.cpp $(call rwildcard,$(gb)/memory/)
obj/gb-cpu.o:       $(gb)/cpu/cpu.cpp $(call rwildcard,$(gb)/cpu/)
obj/gb-ppu.o:       $(gb)/ppu/ppu.cpp $(call rwildcard,$(gb)/ppu/)
obj/gb-apu.o:       $(gb)/apu/apu.cpp $(call rwildcard,$(gb)/apu/)
obj/gb-cheat.o:     $(gb)/cheat/cheat.cpp $(call rwildcard,$(gb)/cheat/)
obj/gb-video.o:     $(gb)/video/video.cpp $(call rwildcard,$(gb)/video/)

## libretro-bsnes-mercury 094%2Bgit20160126

=== debian/control ===
Source: libretro-bsnes-mercury
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Sérgio Benjamim <sergio_br2@yahoo.com.br>
Build-Depends: debhelper-compat (= 12), dh-exec
Standards-Version: 4.3.0
Vcs-Git: https://salsa.debian.org/games-team/libretro-bsnes-mercury.git
Vcs-Browser: https://salsa.debian.org/games-team/libretro-bsnes-mercury
Homepage: https://github.com/libretro/bsnes-mercury

Package: libretro-bsnes-mercury-accuracy
Architecture: any
Multi-Arch: same
Depends: retroarch | libretro-frontend, ${shlibs:Depends}, ${misc:Depends}
Description: Libretro wrapper for bsnes-mercury accuracy core
 This wrapper makes bsnes-mercury accuracy core API compatible with libretro,
 thus allowing its use with libretro frontends, such as RetroArch.
 .
 This core is enabled to emulate only SNES hardware and its subsystems (from
 the command line only), like Super Game Boy, Satellaview and Sufami Turbo.
 .
 bsnes-mercury is a fork of higan, aiming to restore some useful features that
 have been removed, as well as improving performance a bit. Maximum accuracy is
 still uncompromisable; anything that affects accuracy is optional and off by
 default. The name is because metals are shiny, like the accuracy promises of
 bsnes, and mercury is the fastest metal.
 .
 This package comes with the bsnes-mercury accuracy core, which runs 100% of
 SNES games, with perfect emulation of the console. It requires high CPU usage.

Package: libretro-bsnes-mercury-balanced
Architecture: any
Multi-Arch: same
Depends: retroarch | libretro-frontend | gnome-games-app, ${shlibs:Depends}, ${misc:Depends}
Description: Libretro wrapper for bsnes-mercury balanced core
 This wrapper makes bsnes-mercury balanced core API compatible with libretro,
 thus allowing its use with libretro frontends, such as RetroArch.
 .
 This core is enabled to emulate only SNES hardware and its subsystems (from
 the command line only), like Super Game Boy, Satellaview and Sufami Turbo.
 .
 bsnes-mercury is a fork of higan, aiming to restore some useful features that
 have been removed, as well as improving performance a bit. Maximum accuracy is
 still uncompromisable; anything that affects accuracy is optional and off by
 default. The name is because metals are shiny, like the accuracy promises of
 bsnes, and mercury is the fastest metal.
 .
 This package comes with the bsnes-mercury balanced core, which tries to keep
 a good balance between accuracy and performance. It runs almost all SNES games.

Package: libretro-bsnes-mercury-performance
Architecture: any
Multi-Arch: same
Depends: retroarch | libretro-frontend, ${shlibs:Depends}, ${misc:Depends}
Description: Libretro wrapper for bsnes-mercury performance core
 This wrapper makes bsnes-mercury performance core API compatible with libretro,
 thus allowing its use with libretro frontends, such as RetroArch.
 .
 This core is enabled to emulate only SNES hardware and its subsystems (from
 the command line only), like Super Game Boy, Satellaview and Sufami Turbo.
 .
 bsnes-mercury is a fork of higan, aiming to restore some useful features that
 have been removed, as well as improving performance a bit. Maximum accuracy is
 still uncompromisable; anything that affects accuracy is optional and off by
 default. The name is because metals are shiny, like the accuracy promises of
 bsnes, and mercury is the fastest metal.
 .
 This package comes with the bsnes-mercury performance core, which provides
 faster emulation at the cost of reduced accuracy, including problems with some
 games.

## libretro-bsnes-mercury 094+git20160126

=== Makefile ===
sfc_objects := sfc-interface sfc-system sfc-controller
sfc_objects += sfc-cartridge sfc-cheat
sfc_objects += sfc-memory sfc-cpu sfc-smp sfc-dsp sfc-ppu
sfc_objects += sfc-satellaviewbase
sfc_objects += sfc-icd2 sfc-bsx sfc-nss sfc-event
sfc_objects += sfc-sa1 sfc-superfx
sfc_objects += sfc-armdsp sfc-hitachidsp sfc-necdsp
sfc_objects += sfc-epsonrtc sfc-sharprtc
sfc_objects += sfc-spc7110 sfc-sdd1 sfc-obc1
sfc_objects += sfc-hsu1 sfc-msu1
sfc_objects += sfc-satellaviewcart sfc-sufamiturbo
sfc_objects += sfc-hledsp1 sfc-hledsp2 sfc-hledsp3 sfc-hledsp4
sfc_objects += sfc-hlecx4 sfc-hlest0010
sfc_objects += sfc-sgbexternal

ifeq ($(profile),accuracy)
  profflags := -DPROFILE_ACCURACY
  sfccpu := $(sfc)/cpu
  sfcsmp := $(sfc)/smp
  sfcdsp := $(sfc)/dsp
  sfcppu := $(sfc)/ppu
else ifeq ($(profile),balanced)
  profflags := -DPROFILE_BALANCED
  sfccpu := $(sfc)/cpu
  sfcsmp := $(sfc)/smp
  sfcdsp := $(sfc)/alt/dsp
  sfcppu := $(sfc)/alt/ppu-balanced
else ifeq ($(profile),performance)
  profflags := -DPROFILE_PERFORMANCE
  sfccpu := $(sfc)/alt/cpu
  sfcsmp := $(sfc)/alt/smp
  sfcdsp := $(sfc)/alt/dsp
  sfcppu := $(sfc)/alt/ppu-performance
else
  $(error unknown profile.)
endif

obj/sfc-interface-$(profile).o:       $(sfc)/interface/interface.cpp $(call rwildcard,$(sfc)/interface)
obj/sfc-system-$(profile).o:          $(sfc)/system/system.cpp $(call rwildcard,$(sfc)/system/)
obj/sfc-controller-$(profile).o:      $(sfc)/controller/controller.cpp $(call rwildcard,$(sfc)/controller/)
obj/sfc-cartridge-$(profile).o:       $(sfc)/cartridge/cartridge.cpp $(sfc)/cartridge/*
obj/sfc-cheat-$(profile).o:           $(sfc)/cheat/cheat.cpp $(sfc)/cheat/*
obj/sfc-memory-$(profile).o:          $(sfc)/memory/memory.cpp $(call rwildcard,$(sfc)/memory/)
obj/sfc-cpu-$(profile).o:             $(sfccpu)/cpu.cpp $(call rwildcard,$(sfccpu)/)
obj/sfc-smp-$(profile).o:             $(sfcsmp)/smp.cpp $(call rwildcard,$(sfcsmp)/)
obj/sfc-dsp-$(profile).o:             $(sfcdsp)/dsp.cpp $(call rwildcard,$(sfcdsp)/)
obj/sfc-ppu-$(profile).o:             $(sfcppu)/ppu.cpp $(call rwildcard,$(sfcppu)/)

obj/sfc-satellaviewbase-$(profile).o: $(sfc)/base/satellaview/satellaview.cpp $(call rwildcard,$(sfc)/base/satellaview/)

obj/sfc-icd2-$(profile).o:            $(sfc)/chip/icd2/icd2.cpp $(call rwildcard,$(sfc)/chip/icd2/)
obj/sfc-bsx-$(profile).o:             $(sfc)/chip/bsx/bsx.cpp $(call rwildcard,$(sfc)/chip/bsx/)
obj/sfc-nss-$(profile).o:             $(sfc)/chip/nss/nss.cpp $(call rwildcard,$(sfc)/chip/nss/)
obj/sfc-event-$(profile).o:           $(sfc)/chip/event/event.cpp $(call rwildcard,$(sfc)/chip/event/)

obj/sfc-sa1-$(profile).o:             $(sfc)/chip/sa1/sa1.cpp $(call rwildcard,$(sfc)/chip/sa1/)
obj/sfc-superfx-$(profile).o:         $(sfc)/chip/superfx/superfx.cpp $(call rwildcard,$(sfc)/chip/superfx/)

obj/sfc-armdsp-$(profile).o:          $(sfc)/chip/armdsp/armdsp.cpp $(call rwildcard,$(sfc)/chip/armdsp/)
obj/sfc-hitachidsp-$(profile).o:      $(sfc)/chip/hitachidsp/hitachidsp.cpp $(call rwildcard,$(sfc)/chip/hitachidsp/)
obj/sfc-necdsp-$(profile).o:          $(sfc)/chip/necdsp/necdsp.cpp $(call rwildcard,$(sfc)/chip/necdsp/)

obj/sfc-epsonrtc-$(profile).o:        $(sfc)/chip/epsonrtc/epsonrtc.cpp $(call rwildcard,$(sfc)/chip/epsonrtc/)
obj/sfc-sharprtc-$(profile).o:        $(sfc)/chip/sharprtc/sharprtc.cpp $(call rwildcard,$(sfc)/chip/sharprtc/)

obj/sfc-spc7110-$(profile).o:         $(sfc)/chip/spc7110/spc7110.cpp $(sfc)/chip/spc7110/*
obj/sfc-sdd1-$(profile).o:            $(sfc)/chip/sdd1/sdd1.cpp $(sfc)/chip/sdd1/*
obj/sfc-obc1-$(profile).o:            $(sfc)/chip/obc1/obc1.cpp $(sfc)/chip/obc1/*

obj/sfc-hsu1-$(profile).o:            $(sfc)/chip/hsu1/hsu1.cpp $(sfc)/chip/hsu1/*
obj/sfc-msu1-$(profile).o:            $(sfc)/chip/msu1/msu1.cpp $(sfc)/chip/msu1/*

obj/sfc-satellaviewcart-$(profile).o: $(sfc)/slot/satellaview/satellaview.cpp $(call rwildcard,$(sfc)/slot/satellaview/)
obj/sfc-sufamiturbo-$(profile).o:     $(sfc)/slot/sufamiturbo/sufamiturbo.cpp $(call rwildcard,$(sfc)/slot/sufamiturbo/)

obj/sfc-hledsp1-$(profile).o:         $(sfc)/chip/dsp1/dsp1.cpp $(sfc)/chip/dsp1/*
obj/sfc-hledsp2-$(profile).o:         $(sfc)/chip/dsp2/dsp2.cpp $(sfc)/chip/dsp2/*
obj/sfc-hledsp3-$(profile).o:         $(sfc)/chip/dsp3/dsp3.cpp $(sfc)/chip/dsp3/*
obj/sfc-hledsp4-$(profile).o:         $(sfc)/chip/dsp4/dsp4.cpp $(sfc)/chip/dsp4/*

obj/sfc-hlecx4-$(profile).o:          $(sfc)/chip/cx4/cx4.cpp $(sfc)/chip/cx4/*
obj/sfc-hlest0010-$(profile).o:       $(sfc)/chip/st0010/st0010.cpp $(sfc)/chip/st0010/*

obj/sfc-sgbexternal-$(profile).o:     $(sfc)/chip/sgb-external/sgb-external.cpp $(sfc)/chip/sgb-external/*

=== debian/changelog ===
libretro-bsnes-mercury (094+git20160126-2) unstable; urgency=medium

  * Team upload.
  * Apply Ubuntu's packaging changes:
    + Use -O2 optimization, not -O3. Fixes FTBFS on some archs
      (Closes: #861002).
    + Add .libretro metadata for better integration with gnome-games
      (Closes: #911326).
  * Fix file name in Files stanza in debian/copyright.
  * Bump debhelper compat to 11.
  * Enable all hardening flags.
  * Switch Maintainer and Uploaders roles in debian/control.
  * Fix insecure copyright format URI in debian/copyright.
  * Bump Standards-Version to 4.3.0.
  * Remove unnecessary dh argument "--parallel" from debian/rules.
  * Update patches to make the build consider the CPPFLAGS variable.

 -- Fabian Greffrath <fabian@debian.org>  Mon, 04 Feb 2019 17:37:17 +0100

libretro-bsnes-mercury (094+git20160126-1ubuntu2) artful; urgency=medium

  * debian/patches/O2-not-O3-optimization.patch: use -O2 optimization,
    not -O3.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 11 Aug 2017 22:20:14 -0700

libretro-bsnes-mercury (094+git20160126-1ubuntu1) zesty; urgency=medium

  * libretro-bsnes-mercury-balanced:
    - Add appstream and .libretro metadata for better integration
      with gnome-games-app and gnome-software
    - Allow gnome-games-app to be an alternate depends
  * Use dh-exec instead of manual .sh script for install file

 -- Jeremy Bicha <jbicha@ubuntu.com>  Sun, 09 Apr 2017 12:39:21 -0400

libretro-bsnes-mercury (094+git20160126-1) unstable; urgency=low

  * Initial release (Closes: #814356).

 -- Sérgio Benjamim <sergio_br2@yahoo.com.br>  Sun, 10 Apr 2016 22:17:00 -0300

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed -Wl,--no-undefined
export DEB_CXXFLAGS_MAINT_STRIP=-O2
export DEB_CFLAGS_MAINT_STRIP=-O2

ARCH=$(shell dpkg-architecture -qDEB_HOST_ARCH)

ifeq ($(ARCH),armhf)
	ARM=arch=arm
endif

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- profile=accuracy ui=target-libretro $(ARM)
	dh_auto_build -- profile=balanced ui=target-libretro $(ARM)
	dh_auto_build -- profile=performance ui=target-libretro $(ARM)

override_dh_auto_test:

override_dh_auto_clean:
	$(MAKE) clean

## libretro-bsnes-mercury 094+git20220807

=== Makefile ===
DEBUG = 0
FRONTEND_SUPPORTS_RGB565 = 1
PROFILE ?= performance

CORE_DIR := .
CFLAGS :=
CXXFLAGS :=

SPACE :=
SPACE := $(SPACE) $(SPACE)
BACKSLASH :=
BACKSLASH := \$(BACKSLASH)
filter_out1 = $(filter-out $(firstword $1),$1)
filter_out2 = $(call filter_out1,$(call filter_out1,$1))

ifeq ($(platform),)
platform = unix
ifeq ($(shell uname -s),)
   platform = win
else ifneq ($(findstring MINGW,$(shell uname -s)),)
   platform = win
else ifneq ($(findstring Darwin,$(shell uname -s)),)
   platform = osx
else ifneq ($(findstring win,$(shell uname -s)),)
	platform = win
endif
endif

# system platform
system_platform = unix
ifeq ($(shell uname -s),)
	EXE_EXT = .exe
	system_platform = win
else ifneq ($(findstring Darwin,$(shell uname -s)),)
	system_platform = osx
	arch = intel
	ifeq ($(shell uname -p),powerpc)
		arch = ppc
	endif
	ifeq ($(shell uname -p),arm)
		arch = arm
	endif
else ifneq ($(findstring MINGW,$(shell uname -s)),)
	system_platform = win
endif

# profile-guided optimization mode
# pgo := instrument
# pgo := optimize

ifeq ($(PGO),instrument)
  CFLAGS  += -fprofile-generate
  CXXFLAGS  += -fprofile-generate
  LDFLAGS += -lgcov
else ifeq ($(PGO),optimize)
  CFLAGS += -fprofile-use
  CXXFLAGS += -fprofile-use
endif

CORE_DEFINE :=

TARGET_NAME := bsnes_mercury
GIT_VERSION := " $(shell git rev-parse --short HEAD || echo unknown)"
ifneq ($(GIT_VERSION)," unknown")
	CXXFLAGS += -DGIT_VERSION=\"$(GIT_VERSION)\"
endif

ifeq ($(PROFILE), performance)
   TARGET_NAME = bsnes_mercury_performance
else ifeq ($(PROFILE), balanced)
   TARGET_NAME = bsnes_mercury_balanced
else ifeq ($(PROFILE), accuracy)
   TARGET_NAME = bsnes_mercury_accuracy
endif

ifeq ($(platform), unix)
   TARGET := $(TARGET_NAME)_libretro.so
   fpic := -fPIC
   SHARED := -shared -Wl,--no-undefined -Wl,--version-script=target-libretro/link.T
   ifneq ($(shell uname -p | grep -E '((i.|x)86|amd64)'),)
      IS_X86 = 1
   endif
   ifneq ($(findstring Haiku,$(shell uname -s)),)
   CXXFLAGS += -fpermissive
   endif
   LDFLAGS += -ldl
else ifeq ($(platform), osx)
   TARGET := $(TARGET_NAME)_libretro.dylib
   fpic := -fPIC
   SHARED := -dynamiclib
   MINVERSION :=
ifeq ($(arch),ppc)
   ENDIANNESS_DEFINES := -DMSB_FIRST
   OLD_GCC := 1
endif
   OSXVER = `sw_vers -productVersion | cut -d. -f 2`
   OSX_LT_MAVERICKS = `(( $(OSXVER) <= 9)) && echo "YES"`
   FLAGS += -DHAVE_POSIX_MEMALIGN
   ifeq ($(OSX_LT_MAVERICKS),YES)
      MINVERSION = -mmacosx-version-min=10.1
   endif
   FLAGS += $(MINVERSION)

   ifeq ($(CROSS_COMPILE),1)
      TARGET_RULE   = -target $(LIBRETRO_APPLE_PLATFORM) -isysroot $(LIBRETRO_APPLE_ISYSROOT)
      CFLAGS   += $(TARGET_RULE)
      CPPFLAGS += $(TARGET_RULE)
      CXXFLAGS += $(TARGET_RULE)
      LDFLAGS  += $(TARGET_RULE)
   endif

   CFLAGS  += $(ARCHFLAGS)
   CXXFLAGS  += $(ARCHFLAGS)
   LDFLAGS += $(ARCHFLAGS)

# iOS
else ifneq (,$(findstring ios,$(platform)))

   TARGET := $(TARGET_NAME)_libretro_ios.dylib
   fpic := -fPIC
   SHARED := -dynamiclib
   MINVERSION := 

ifeq ($(IOSSDK),)
   IOSSDK := $(shell xcodebuild -version -sdk iphoneos Path)
endif

ifeq ($(platform),ios-arm64)
   CC = cc -arch arm64 -isysroot $(IOSSDK)
   CXX = c++ -arch arm64 -isysroot $(IOSSDK)
else
   CC = cc -arch armv7 -isysroot $(IOSSDK)
   CXX = c++ -arch armv7 -isysroot $(IOSSDK)
endif
ifeq ($(platform),$(filter $(platform),ios9 ios-arm64))
	MINVERSION = -miphoneos-version-min=8.0
else
	MINVERSION = -miphoneos-version-min=5.0
endif
   LDFLAGS += $(MINVERSION)
   FLAGS += $(MINVERSION)
   FLAGS += -DHAVE_POSIX_MEMALIGN

# tvOS
else ifeq ($(platform), tvos-arm64)
   TARGET := $(TARGET_NAME)_libretro_tvos.dylib
   fpic := -fPIC
   SHARED := -dynamiclib

ifeq ($(IOSSDK),)
   IOSSDK := $(shell xcodebuild -version -sdk appletvos Path)
endif

   CC = cc -arch arm64 -isysroot $(IOSSDK)
   CXX = c++ -arch arm64 -isysroot $(IOSSDK) 
   FLAGS += -DHAVE_POSIX_MEMALIGN

# Raspberry Pi 4 in 64bit mode
else ifeq ($(platform), rpi4_64)
   TARGET := $(TARGET_NAME)_libretro.so
   fpic := -fPIC
   SHARED := -shared -Wl,--no-undefined -Wl,--version-script=target-libretro/link.T
   FLAGS += -march=armv8-a+crc+simd -mtune=cortex-a72
   ASFLAGS += -march=armv8-a+crc+simd -mtune=cortex-a72
   LDFLAGS += -ldl
   IS_X86 = 0

# tvOS
else ifeq ($(platform), tvos-arm64)
   TARGET := $(TARGET_NAME)_libretro_tvos.dylib
   fpic := -fPIC
   SHARED := -dynamiclib

ifeq ($(IOSSDK),)
   IOSSDK := $(shell xcodebuild -version -sdk appletvos Path)
endif

else ifeq ($(platform), qnx)
   TARGET := $(TARGET_NAME)_libretro_$(platform).so
   fpic := -fPIC
   SHARED := -lcpp -lm -shared -Wl,--no-undefined -Wl,--version-script=target-libretro/link.T
   CC = qcc -Vgcc_ntoarmv7le
   CXX = QCC -Vgcc_ntoarmv7le_cpp
   AR = QCC -Vgcc_ntoarmv7le
   FLAGS += -D__BLACKBERRY_QNX__ -marm -mcpu=cortex-a9 -mfpu=neon -mfloat-abi=softfp
else ifeq ($(platform), ps3)
   TARGET := $(TARGET_NAME)_libretro_$(platform).a
   CC = $(CELL_SDK)/host-win32/ppu/bin/ppu-lv2-gcc.exe
   CXX = $(CELL_SDK)/host-win32/ppu/bin/ppu-lv2-g++.exe
   AR = $(CELL_SDK)/host-win32/ppu/bin/ppu-lv2-ar.exe
   ENDIANNESS_DEFINES := -DMSB_FIRST
   OLD_GCC := 1
   FLAGS += -DARCH_POWERPC_ALTIVEC
   STATIC_LINKING = 1
else ifeq ($(platform), sncps3)
   TARGET := $(TARGET_NAME)_libretro_ps3.a
   CC = $(CELL_SDK)/host-win32/sn/bin/ps3ppusnc.exe
   CXX = $(CELL_SDK)/host-win32/sn/bin/ps3ppusnc.exe
   AR = $(CELL_SDK)/host-win32/sn/bin/ps3snarl.exe
   ENDIANNESS_DEFINES := -DMSB_FIRST
   CXXFLAGS += -Xc+=exceptions
   OLD_GCC := 1
   NO_GCC := 1
   FLAGS += -DARCH_POWERPC_ALTIVEC
   STATIC_LINKING = 1
else ifeq ($(platform), psl1ght)
   TARGET := $(TARGET_NAME)_libretro_$(platform).a
   CC = $(PS3DEV)/ppu/bin/ppu-gcc$(EXE_EXT)
   CXX = $(PS3DEV)/ppu/bin/ppu-g++$(EXE_EXT)
   AR = $(PS3DEV)/ppu/bin/ppu-ar$(EXE_EXT)
   ENDIANNESS_DEFINES := -DMSB_FIRST
   STATIC_LINKING = 1

# PSP
else ifeq ($(platform), psp1)
   TARGET := $(TARGET_NAME)_libretro_$(platform).a
   CC = psp-gcc$(EXE_EXT)
   CXX = psp-g++$(EXE_EXT)
   AR = psp-ar$(EXE_EXT)
   FLAGS += -DPSP -G0
   STATIC_LINKING = 1
   EXTRA_INCLUDES := -I$(shell psp-config --pspsdk-path)/include

# Vita
else ifeq ($(platform), vita)
   TARGET := $(TARGET_NAME)_libretro_$(platform).a
	CC = arm-vita-eabi-gcc$(EXE_EXT)
	CXX = arm-vita-eabi-g++$(EXE_EXT)
	AR = arm-vita-eabi-ar$(EXE_EXT)
   FLAGS += -DVITA
   STATIC_LINKING = 1

# Xbox 360
else ifeq ($(platform), xenon)
   TARGET := $(TARGET_NAME)_libretro_xenon360.a
   CC = xenon-gcc$(EXE_EXT)
   CXX = xenon-g++$(EXE_EXT)
   AR = xenon-ar$(EXE_EXT)
   ENDIANNESS_DEFINES += -D__LIBXENON__ -m32 -D__ppc__ -DMSB_FIRST
   LIBS :=
   STATIC_LINKING = 1

# Nintendo Switch (libnx)
else ifeq ($(platform), libnx)
include $(DEVKITPRO)/libnx/switch_rules
    TARGET := $(TARGET_NAME)_libretro_$(platform).a
    DEFINES := -DSWITCH=1 -U__linux__ -U__linux -DRARCH_INTERNAL
    CFLAGS  +=  $(DEFINES) -fPIE -I$(LIBNX)/include/ -ffunction-sections -fdata-sections -ftls-model=local-exec -Wl,--allow-multiple-definition -specs=$(LIBNX)/switch.specs
    CFLAGS  += $(INCDIRS)
    CFLAGS  += $(INCLUDE)  -D__SWITCH__ -DHAVE_LIBNX
    CXXFLAGS += $(ASFLAGS) $(CFLAGS) -fexceptions -fno-rtti -std=gnu++11 
    CFLAGS += -std=gnu11
    STATIC_LINKING = 1

# Nintendo Gamecube
else ifeq ($(platform), ngc)
   TARGET := $(TARGET_NAME)_libretro_$(platform).a
   CC = $(DEVKITPPC)/bin/powerpc-eabi-gcc$(EXE_EXT)
   CXX = $(DEVKITPPC)/bin/powerpc-eabi-g++$(EXE_EXT)
   AR = $(DEVKITPPC)/bin/powerpc-eabi-ar$(EXE_EXT)
   ENDIANNESS_DEFINES += -DGEKKO -DHW_DOL -mrvl -mcpu=750 -meabi -mhard-float -DMSB_FIRST
   FLAGS += -U__INT32_TYPE__ -U __UINT32_TYPE__ -D__INT32_TYPE__=int

   EXTRA_INCLUDES := -I$(DEVKITPRO)/libogc/include
   STATIC_LINKING = 1

# wii
else ifeq ($(platform), wii)
   TARGET := $(TARGET_NAME)_libretro_$(platform).a
   CC = $(DEVKITPPC)/bin/powerpc-eabi-gcc$(EXE_EXT)
   CXX = $(DEVKITPPC)/bin/powerpc-eabi-g++$(EXE_EXT)
   AR = $(DEVKITPPC)/bin/powerpc-eabi-ar$(EXE_EXT)
   ENDIANNESS_DEFINES += -DGEKKO -DHW_RVL -mrvl -mcpu=750 -meabi -mhard-float -DMSB_FIRST
   FLAGS += -U__INT32_TYPE__ -U __UINT32_TYPE__ -D__INT32_TYPE__=int

   EXTRA_INCLUDES := -I$(DEVKITPRO)/libogc/include
   STATIC_LINKING = 1

# wiiu
else ifeq ($(platform), wiiu)
   TARGET := $(TARGET_NAME)_libretro_$(platform).a
   CC = $(DEVKITPPC)/bin/powerpc-eabi-gcc$(EXE_EXT)
   CXX = $(DEVKITPPC)/bin/powerpc-eabi-g++$(EXE_EXT)
   AR = $(DEVKITPPC)/bin/powerpc-eabi-ar$(EXE_EXT)
   ENDIANNESS_DEFINES += -DGEKKO -DWIIU -DHW_RVL -mwup -mcpu=750 -meabi -mhard-float -DMSB_FIRST
   FLAGS += -U__INT32_TYPE__ -U __UINT32_TYPE__ -D__INT32_TYPE__=int

   EXTRA_INCLUDES := -I$(DEVKITPRO)/libogc/include
   STATIC_LINKING = 1

else ifneq (,$(findstring armv,$(platform)))
   TARGET := $(TARGET_NAME)_libretro.so
   fpic := -fPIC
   SHARED := -shared -Wl,--no-undefined -Wl,--version-script=target-libretro/link.T
   CC ?= gcc
   IS_X86 = 0
ifneq (,$(findstring cortexa8,$(platform)))
   FLAGS += -marm -mcpu=cortex-a8
   ASFLAGS += -mcpu=cortex-a8
else ifneq (,$(findstring cortexa9,$(platform)))
   FLAGS += -marm -mcpu=cortex-a9
   ASFLAGS += -mcpu=cortex-a9
endif

ifneq (,$(findstring neon,$(platform)))
   FLAGS += -mfpu=neon
   ASFLAGS += -mfpu=neon
   HAVE_NEON = 1
endif
ifneq (,$(findstring softfloat,$(platform)))
   FLAGS += -mfloat-abi=softfp
else ifneq (,$(findstring hardfloat,$(platform)))
   FLAGS += -mfloat-abi=hard
endif
   arch = arm
   LDFLAGS += -ldl

# Windows MSVC 2017 all architectures
else ifneq (,$(findstring windows_msvc2017,$(platform)))

    NO_GCC := 1
    CFLAGS   += -DNOMINMAX
    CXXFLAGS += -DNOMINMAX
    WINDOWS_VERSION = 1

	PlatformSuffix = $(subst windows_msvc2017_,,$(platform))
	ifneq (,$(findstring desktop,$(PlatformSuffix)))
		WinPartition = desktop
		MSVC2017CompileFlags = -DWINAPI_FAMILY=WINAPI_FAMILY_DESKTOP_APP -FS
		LDFLAGS += -MANIFEST -LTCG:incremental -NXCOMPAT -DYNAMICBASE -DEBUG -OPT:REF -INCREMENTAL:NO -SUBSYSTEM:WINDOWS -MANIFESTUAC:"level='asInvoker' uiAccess='false'" -OPT:ICF -ERRORREPORT:PROMPT -NOLOGO -TLBID:1
		LIBS += kernel32.lib user32.lib gdi32.lib winspool.lib comdlg32.lib advapi32.lib
	else ifneq (,$(findstring uwp,$(PlatformSuffix)))
		WinPartition = uwp
		MSVC2017CompileFlags = -DWINAPI_FAMILY=WINAPI_FAMILY_APP -D_WINDLL -D_UNICODE -DUNICODE -D__WRL_NO_DEFAULT_LIB__ -EHsc -FS
		LDFLAGS += -APPCONTAINER -NXCOMPAT -DYNAMICBASE -MANIFEST:NO -LTCG -OPT:REF -SUBSYSTEM:CONSOLE -MANIFESTUAC:NO -OPT:ICF -ERRORREPORT:PROMPT -NOLOGO -TLBID:1 -DEBUG:FULL -WINMD:NO
		LIBS += WindowsApp.lib
	endif

	CFLAGS += $(MSVC2017CompileFlags)
	CXXFLAGS += $(MSVC2017CompileFlags)

	TargetArchMoniker = $(subst $(WinPartition)_,,$(PlatformSuffix))

	CC  = cl.exe
	CXX = cl.exe
	LD = link.exe

	reg_query = $(call filter_out2,$(subst $2,,$(shell reg query "$2" -v "$1" 2>nul)))
	fix_path = $(subst $(SPACE),\ ,$(subst \,/,$1))

	ProgramFiles86w := $(shell cmd //c "echo %PROGRAMFILES(x86)%")
	ProgramFiles86 := $(shell cygpath "$(ProgramFiles86w)")

	WindowsSdkDir ?= $(call reg_query,InstallationFolder,HKEY_LOCAL_MACHINE\SOFTWARE\Wow6432Node\Microsoft\Microsoft SDKs\Windows\v10.0)
	WindowsSdkDir ?= $(call reg_query,InstallationFolder,HKEY_CURRENT_USER\SOFTWARE\Wow6432Node\Microsoft\Microsoft SDKs\Windows\v10.0)
	WindowsSdkDir ?= $(call reg_query,InstallationFolder,HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Microsoft SDKs\Windows\v10.0)
	WindowsSdkDir ?= $(call reg_query,InstallationFolder,HKEY_CURRENT_USER\SOFTWARE\Microsoft\Microsoft SDKs\Windows\v10.0)
	WindowsSdkDir := $(WindowsSdkDir)

	WindowsSDKVersion ?= $(firstword $(foreach folder,$(subst $(subst \,/,$(WindowsSdkDir)Include/),,$(wildcard $(call fix_path,$(WindowsSdkDir)Include\*))),$(if $(wildcard $(call fix_path,$(WindowsSdkDir)Include/$(folder)/um/Windows.h)),$(folder),)))$(BACKSLASH)
	WindowsSDKVersion := $(WindowsSDKVersion)

	VsInstallBuildTools = $(ProgramFiles86)/Microsoft Visual Studio/2017/BuildTools
	VsInstallEnterprise = $(ProgramFiles86)/Microsoft Visual Studio/2017/Enterprise

=== ananke/Makefile ===
include ../nall/Makefile
include ../phoenix/Makefile

path := /usr/local/lib
flags := $(flags) -O3 -fomit-frame-pointer -I..

all:
	$(compiler) $(cppflags) $(flags) -fPIC -o obj/ananke.o -c ananke.cpp
ifeq ($(platform),windows)
	$(compiler) $(phoenixflags) -fPIC -o obj/phoenix.o -c ../phoenix/phoenix.cpp
	$(compiler) $(link) -shared -o phoenix.dll obj/phoenix.o $(phoenixlink)
	$(compiler) $(link) -shared -o ananke.dll obj/ananke.o -L. -lphoenix
else ifeq ($(platform),macosx)
	$(compiler) $(link) -shared -dynamiclib -undefined suppress -flat_namespace -o libananke.dylib obj/ananke.o
else
	$(compiler) $(link) -shared -Wl,-soname,libananke.so.1 -o libananke.so obj/ananke.o
endif

resource: force
	sourcery resource/resource.bml resource/resource.cpp resource/resource.hpp

clean:
	-$(call delete,obj/*.o)
	-$(call delete,*.dll)
	-$(call delete,*.so)

install: uninstall
ifeq ($(platform),windows)
else ifeq ($(platform),macosx)
	if [ ! -d ~/Library/Application\ Support/ananke ]; then mkdir ~/Library/Application\ Support/ananke; fi
	sudo cp libananke.dylib $(path)/libananke.1.dylib
	sudo ln -s $(path)/libananke.1.dylib $(path)/libananke.dylib
else
	if [ ! -d ~/.config/ananke ]; then mkdir ~/.config/ananke; fi
	sudo cp libananke.so $(path)/libananke.so.1
	sudo ln -s $(path)/libananke.so.1 $(path)/libananke.so
endif

uninstall:
ifeq ($(platform),windows)
else ifeq ($(platform),macosx)
	if [ -f $(path)/libananke.dylib ]; then sudo rm $(path)/libananke.dylib; fi
	if [ -f $(path)/libananke.1.dylib ]; then sudo rm $(path)/libananke.1.dylib; fi
else
	if [ -f $(path)/libananke.so ]; then sudo rm $(path)/libananke.so; fi
	if [ -f $(path)/libananke.so.1 ]; then sudo rm $(path)/libananke.so.1; fi
endif

force:

=== fc/Makefile ===
fc_objects := fc-interface fc-system fc-scheduler fc-input
fc_objects += fc-memory fc-cartridge fc-cpu fc-apu fc-ppu
fc_objects += fc-cheat fc-video
objects += $(fc_objects)

obj/fc-interface.o: $(fc)/interface/interface.cpp $(call rwildcard,$(fc)/interface/)
obj/fc-system.o: $(fc)/system/system.cpp $(call rwildcard,$(fc)/system/)
obj/fc-scheduler.o: $(fc)/scheduler/scheduler.cpp $(call rwildcard,$(fc)/scheduler/)
obj/fc-input.o: $(fc)/input/input.cpp $(call rwildcard,$(fc)/input/)
obj/fc-memory.o: $(fc)/memory/memory.cpp $(call rwildcard,$(fc)/memory/)
obj/fc-cartridge.o: $(fc)/cartridge/cartridge.cpp $(call rwildcard,$(fc)/cartridge/)
obj/fc-cpu.o: $(fc)/cpu/cpu.cpp $(call rwildcard,$(fc)/cpu/)
obj/fc-apu.o: $(fc)/apu/apu.cpp $(call rwildcard,$(fc)/apu/)
obj/fc-ppu.o: $(fc)/ppu/ppu.cpp $(call rwildcard,$(fc)/ppu/)
obj/fc-cheat.o: $(fc)/cheat/cheat.cpp $(call rwildcard,$(fc)/cheat/)
obj/fc-video.o: $(fc)/video/video.cpp $(call rwildcard,$(fc)/video/)

=== gba/Makefile ===
gba_objects := gba-memory gba-interface gba-scheduler gba-system
gba_objects += gba-video gba-cartridge gba-player
gba_objects += gba-cpu gba-ppu gba-apu
objects += $(gba_objects)

obj/gba-memory.o:    $(gba)/memory/memory.cpp $(call rwildcard,$(gba)/memory)
obj/gba-interface.o: $(gba)/interface/interface.cpp $(call rwildcard,$(gba)/interface)
obj/gba-scheduler.o: $(gba)/scheduler/scheduler.cpp $(call rwildcard,$(gba)/scheduler)
obj/gba-system.o:    $(gba)/system/system.cpp $(call rwildcard,$(gba)/system)
obj/gba-video.o:     $(gba)/video/video.cpp $(call rwildcard,$(gba)/video)
obj/gba-cartridge.o: $(gba)/cartridge/cartridge.cpp $(call rwildcard,$(gba)/cartridge)
obj/gba-player.o:    $(gba)/player/player.cpp $(call rwildcard,$(gba)/player)
obj/gba-cpu.o:       $(gba)/cpu/cpu.cpp $(call rwildcard,$(gba)/cpu)
obj/gba-ppu.o:       $(gba)/ppu/ppu.cpp $(call rwildcard,$(gba)/ppu)
obj/gba-apu.o:       $(gba)/apu/apu.cpp $(call rwildcard,$(gba)/apu)

=== nall/Makefile ===
# Makefile
# author: byuu
# license: public domain

[A-Z] = A B C D E F G H I J K L M N O P Q R S T U V W X Y Z
[a-z] = a b c d e f g h i j k l m n o p q r s t u v w x y z
[0-9] = 0 1 2 3 4 5 6 7 8 9
[markup] = ` ~ ! @ \# $$ % ^ & * ( ) - _ = + [ { ] } \ | ; : ' " , < . > / ?
# Some editors need this for proper syntax highlighting: '
[all] = $([A-Z]) $([a-z]) $([0-9]) $([markup])
[space] :=
[space] +=

# platform detection
ifeq ($(platform),)
  uname := $(shell uname -s)
  ifeq ($(uname),)
    platform := windows
  else ifneq ($(findstring Windows,$(uname)),)
    platform := windows
  else ifneq ($(findstring CYGWIN,$(uname)),)
    platform := windows
  else ifneq ($(findstring MINGW,$(uname)),)
    platform := windows
  else ifneq ($(findstring Darwin,$(uname)),)
    platform := macosx
  else ifneq ($(findstring BSD,$(uname)),)
    platform := bsd
  else ifneq ($(findstring Haiku,$(uname)),)
	platform := haiku
  else
    platform := linux
  endif
endif

ifeq ($(platform),windows)
  delete = del /F /Q $(subst /,\,$1)
else
  delete = rm -f $1
endif

# compiler detection
ifeq ($(compiler),)
  ifneq ($(CXX),)
    compiler := $(CXX)
    flags :=
    link := $(LDFLAGS)
  else ifeq ($(platform),windows)
    compiler := g++
    flags :=
    link :=
  else ifeq ($(platform),macosx)
    compiler := clang++
    flags := -w -stdlib=libc++
    link := -lc++ -lobjc
  else ifeq ($(platform),bsd)
    compiler := clang++
    flags := -w -I/usr/local/include
  else
    compiler := g++
    flags :=
    link := $(LDFLAGS)
  endif

  cflags := -x c -std=c99
  objcflags := -x objective-c -std=c99
  cppflags := -x c++ -std=c++11
  objcppflags := -x objective-c++ -std=c++11
endif

# cross-compilation support
ifeq ($(arch),x86)
  flags := -m32 $(flags)
  link := -m32 $(link)
endif

ifeq ($(prefix),)
  prefix := /usr/local
endif

# function rwildcard(directory, pattern)
rwildcard = \
  $(strip \
    $(filter $(if $2,$2,%), \
      $(foreach f, \
        $(wildcard $1*), \
        $(eval t = $(call rwildcard,$f/)) \
        $(if $t,$t,$f) \
      ) \
    ) \
  )

# function strtr(source, from, to)
strtr = \
  $(eval __temp := $1) \
  $(strip \
    $(foreach c, \
      $(join $(addsuffix :,$2),$3), \
      $(eval __temp := \
        $(subst $(word 1,$(subst :, ,$c)),$(word 2,$(subst :, ,$c)),$(__temp)) \
      ) \
    ) \
    $(__temp) \
  )

# function strupper(source)
strupper = $(call strtr,$1,$([a-z]),$([A-Z]))

# function strlower(source)
strlower = $(call strtr,$1,$([A-Z]),$([a-z]))

# function strlen(source)
strlen = \
  $(eval __temp := $(subst $([space]),_,$1)) \
  $(words \
    $(strip \
      $(foreach c, \
        $([all]), \
        $(eval __temp := \
          $(subst $c,$c ,$(__temp)) \
        ) \
      ) \
      $(__temp) \
    ) \
  )

# function streq(source)
streq = $(if $(filter-out xx,x$(subst $1,,$2)$(subst $2,,$1)x),,1)

# function strne(source)
strne = $(if $(filter-out xx,x$(subst $1,,$2)$(subst $2,,$1)x),1,)

=== phoenix/Makefile ===
ifeq ($(platform),)
  phoenixflags = $(cppflags) $(flags) -DPHOENIX_REFERENCE
  phoenixlink =
else ifeq ($(platform),windows)
  phoenixflags = $(cppflags) $(flags) -DPHOENIX_WINDOWS
  phoenixlink = -lkernel32 -luser32 -lgdi32 -ladvapi32 -lole32 -lcomctl32 -lcomdlg32 -luxtheme -lmsimg32 -lshlwapi
else ifeq ($(platform),macosx)
  phoenixflags = $(objcppflags) $(flags) -DPHOENIX_COCOA
  phoenixlink = -framework Cocoa -framework Carbon
else
  ifeq ($(phoenix),)
    phoenix := gtk
  endif

  ifeq ($(phoenix),gtk)
    phoenixflags = $(cppflags) $(flags) -DPHOENIX_GTK `pkg-config --cflags gtk+-2.0`
    phoenixlink = `pkg-config --libs gtk+-2.0`
  endif

  ifeq ($(phoenix),qt)
    phoenixflags = $(cppflags) $(flags) -DPHOENIX_QT `pkg-config --cflags QtCore QtGui`
    phoenixlink = `pkg-config --libs QtCore QtGui`
  endif
endif

=== sfc/Makefile ===
sfc_objects := sfc-interface sfc-system sfc-controller
sfc_objects += sfc-cartridge sfc-cheat
sfc_objects += sfc-memory sfc-cpu sfc-smp sfc-dsp sfc-ppu
sfc_objects += sfc-satellaviewbase
sfc_objects += sfc-icd2 sfc-bsx sfc-nss sfc-event
sfc_objects += sfc-sa1 sfc-superfx
sfc_objects += sfc-armdsp sfc-hitachidsp sfc-necdsp
sfc_objects += sfc-epsonrtc sfc-sharprtc
sfc_objects += sfc-spc7110 sfc-sdd1 sfc-obc1
sfc_objects += sfc-hsu1 sfc-msu1
sfc_objects += sfc-satellaviewcart sfc-sufamiturbo
sfc_objects += sfc-hledsp1 sfc-hledsp2 sfc-hledsp3 sfc-hledsp4
sfc_objects += sfc-hlecx4 sfc-hlest0010
sfc_objects += sfc-sgbexternal

ifeq ($(profile),accuracy)
  profflags := -DPROFILE_ACCURACY
  sfccpu := $(sfc)/cpu
  sfcsmp := $(sfc)/smp
  sfcdsp := $(sfc)/dsp
  sfcppu := $(sfc)/ppu
else ifeq ($(profile),balanced)
  profflags := -DPROFILE_BALANCED
  sfccpu := $(sfc)/cpu
  sfcsmp := $(sfc)/smp
  sfcdsp := $(sfc)/alt/dsp
  sfcppu := $(sfc)/alt/ppu-balanced
else ifeq ($(profile),performance)
  profflags := -DPROFILE_PERFORMANCE
  sfccpu := $(sfc)/alt/cpu
  sfcsmp := $(sfc)/alt/smp
  sfcdsp := $(sfc)/alt/dsp
  sfcppu := $(sfc)/alt/ppu-performance
else
  $(error unknown profile.)
endif

ifeq ($(sfc_lagfix),1)
	flags += -DSFC_LAGFIX
endif

obj/sfc-interface-$(profile).o:       $(sfc)/interface/interface.cpp $(call rwildcard,$(sfc)/interface)
obj/sfc-system-$(profile).o:          $(sfc)/system/system.cpp $(call rwildcard,$(sfc)/system/)
obj/sfc-controller-$(profile).o:      $(sfc)/controller/controller.cpp $(call rwildcard,$(sfc)/controller/)
obj/sfc-cartridge-$(profile).o:       $(sfc)/cartridge/cartridge.cpp $(sfc)/cartridge/*
obj/sfc-cheat-$(profile).o:           $(sfc)/cheat/cheat.cpp $(sfc)/cheat/*
obj/sfc-memory-$(profile).o:          $(sfc)/memory/memory.cpp $(call rwildcard,$(sfc)/memory/)
obj/sfc-cpu-$(profile).o:             $(sfccpu)/cpu.cpp $(call rwildcard,$(sfccpu)/)
obj/sfc-smp-$(profile).o:             $(sfcsmp)/smp.cpp $(call rwildcard,$(sfcsmp)/)
obj/sfc-dsp-$(profile).o:             $(sfcdsp)/dsp.cpp $(call rwildcard,$(sfcdsp)/)
obj/sfc-ppu-$(profile).o:             $(sfcppu)/ppu.cpp $(call rwildcard,$(sfcppu)/)

obj/sfc-satellaviewbase-$(profile).o: $(sfc)/base/satellaview/satellaview.cpp $(call rwildcard,$(sfc)/base/satellaview/)

obj/sfc-icd2-$(profile).o:            $(sfc)/chip/icd2/icd2.cpp $(call rwildcard,$(sfc)/chip/icd2/)
obj/sfc-bsx-$(profile).o:             $(sfc)/chip/bsx/bsx.cpp $(call rwildcard,$(sfc)/chip/bsx/)
obj/sfc-nss-$(profile).o:             $(sfc)/chip/nss/nss.cpp $(call rwildcard,$(sfc)/chip/nss/)
obj/sfc-event-$(profile).o:           $(sfc)/chip/event/event.cpp $(call rwildcard,$(sfc)/chip/event/)

obj/sfc-sa1-$(profile).o:             $(sfc)/chip/sa1/sa1.cpp $(call rwildcard,$(sfc)/chip/sa1/)
obj/sfc-superfx-$(profile).o:         $(sfc)/chip/superfx/superfx.cpp $(call rwildcard,$(sfc)/chip/superfx/)

obj/sfc-armdsp-$(profile).o:          $(sfc)/chip/armdsp/armdsp.cpp $(call rwildcard,$(sfc)/chip/armdsp/)
obj/sfc-hitachidsp-$(profile).o:      $(sfc)/chip/hitachidsp/hitachidsp.cpp $(call rwildcard,$(sfc)/chip/hitachidsp/)
obj/sfc-necdsp-$(profile).o:          $(sfc)/chip/necdsp/necdsp.cpp $(call rwildcard,$(sfc)/chip/necdsp/)

obj/sfc-epsonrtc-$(profile).o:        $(sfc)/chip/epsonrtc/epsonrtc.cpp $(call rwildcard,$(sfc)/chip/epsonrtc/)
obj/sfc-sharprtc-$(profile).o:        $(sfc)/chip/sharprtc/sharprtc.cpp $(call rwildcard,$(sfc)/chip/sharprtc/)

obj/sfc-spc7110-$(profile).o:         $(sfc)/chip/spc7110/spc7110.cpp $(sfc)/chip/spc7110/*
obj/sfc-sdd1-$(profile).o:            $(sfc)/chip/sdd1/sdd1.cpp $(sfc)/chip/sdd1/*
obj/sfc-obc1-$(profile).o:            $(sfc)/chip/obc1/obc1.cpp $(sfc)/chip/obc1/*

obj/sfc-hsu1-$(profile).o:            $(sfc)/chip/hsu1/hsu1.cpp $(sfc)/chip/hsu1/*
obj/sfc-msu1-$(profile).o:            $(sfc)/chip/msu1/msu1.cpp $(sfc)/chip/msu1/*

obj/sfc-satellaviewcart-$(profile).o: $(sfc)/slot/satellaview/satellaview.cpp $(call rwildcard,$(sfc)/slot/satellaview/)
obj/sfc-sufamiturbo-$(profile).o:     $(sfc)/slot/sufamiturbo/sufamiturbo.cpp $(call rwildcard,$(sfc)/slot/sufamiturbo/)

obj/sfc-hledsp1-$(profile).o:         $(sfc)/chip/dsp1/dsp1.cpp $(sfc)/chip/dsp1/*
obj/sfc-hledsp2-$(profile).o:         $(sfc)/chip/dsp2/dsp2.cpp $(sfc)/chip/dsp2/*
obj/sfc-hledsp3-$(profile).o:         $(sfc)/chip/dsp3/dsp3.cpp $(sfc)/chip/dsp3/*
obj/sfc-hledsp4-$(profile).o:         $(sfc)/chip/dsp4/dsp4.cpp $(sfc)/chip/dsp4/*

obj/sfc-hlecx4-$(profile).o:          $(sfc)/chip/cx4/cx4.cpp $(sfc)/chip/cx4/*
obj/sfc-hlest0010-$(profile).o:       $(sfc)/chip/st0010/st0010.cpp $(sfc)/chip/st0010/*

obj/sfc-sgbexternal-$(profile).o:     $(sfc)/chip/sgb-external/sgb-external.cpp $(sfc)/chip/sgb-external/*

=== target-libretro/Makefile ===
processors := arm hg51b upd96050 gsu r65816 spc700 lr35902
include processor/Makefile

include sfc/Makefile
include gb/Makefile
output := libretro

core_installdir := $(prefix)/lib

ifeq ($(platform),linux)
  flags += -fPIC
  ifeq ($(arch),arm)
    flags += -marm
  endif
else ifeq ($(platform),bsd)
  flags += -fPIC
else ifeq ($(platform),macosx)
  flags += -fPIC
else ifneq (,$(findstring ios,$(platform)))
  ifeq ($(IOSSDK),)
    IOSSDK := $(shell xcodebuild -version -sdk iphoneos Path)
  endif
  flags += -arch armv7 -fPIC -isysroot $(IOSSDK) -marm -DHAVE_POSIX_MEMALIGN=1 -DIOS -w
ifeq ($(platform),ios9)
	flags += -miphoneos-version-min=8.0
else
	flags += -miphoneos-version-min=5.0
endif
endif

flags += -D__LIBRETRO__

GIT_VERSION ?= " $(shell git rev-parse --short HEAD || echo unknown)"
ifneq ($(GIT_VERSION)," unknown")
	flags += -DGIT_VERSION=\"$(GIT_VERSION)\"
endif

#rules
objects := $(patsubst %,obj/%.o,$(objects))
sfc_objects += libretro
sfc_objects := $(patsubst %,obj/%-$(profile).o,$(sfc_objects))
objects += $(sfc_objects)

obj/libretro-$(profile).o: $(ui)/libretro.cpp $(ui)/*

#targets
build: $(objects)
ifeq ($(platform),linux)
	$(compiler) -o out/bsnes_mercury_$(profile)_libretro.so -shared $(objects) -ldl -Wl,--no-undefined -Wl,--version-script=$(ui)/link.T $(link)
else ifeq ($(platform),bsd)
	$(compiler) -o out/bsnes_mercury_$(profile)_libretro.so -shared $(objects) -ldl -Wl,--no-undefined -Wl,--version-script=$(ui)/link.T $(link)
else ifeq ($(platform),haiku)
	$(compiler) -o out/bsnes_mercury_$(profile)_libretro.so -shared $(objects) -lroot -lnetwork -Wl,--no-undefined -Wl,--version-script=$(ui)/link.T $(link)
else ifneq (,$(findstring ios,$(platform)))
	$(compiler) -o out/bsnes_mercury_$(profile)_libretro_ios.dylib -dynamiclib $(objects) -isysroot $(IOSSDK) -arch armv7 $(link)
else ifeq ($(platform),macosx)
ifdef ($(NOUNIVERSAL))
	$(compiler) -o out/bsnes_mercury_$(profile)_libretro.dylib -dynamiclib $(objects) $(link)
else
	$(compiler) $(ARCHFLAGS) -o out/bsnes_mercury_$(profile)_libretro.dylib -dynamiclib $(objects) $(link)
endif
else ifeq ($(platform),windows)
	$(compiler) -o out/bsnes_mercury_$(profile)_libretro.dll -shared $(objects) -Wl,--no-undefined -Wl,--version-script=$(ui)/link.T -static-libgcc -static-libstdc++ -lws2_32 $(link)
else
	$(error invalid platform: $(platform). valid platforms are: windows linux macosx ios bsd)
endif

install:
ifeq ($(platform),linux)
	install -D -m 755 out/bsnes_mercury_$(profile)_libretro.so $(DESTDIR)$(core_installdir)/bsnes_mercury_$(profile)_libretro.so
else ifeq ($(platform),bsd)
	install -D -m 755 out/bsnes_mercury_$(profile)_libretro.so $(DESTDIR)$(core_installdir)/bsnes_mercury_$(profile)_libretro.so
else ifeq ($(platform),macosx)
	cp out/bsnes_mercury_$(profile)_libretro.dylib $(DESTDIR)$(core_installdir)/bsnes_mercury_$(profile)_libretro.dylib
else ifneq (,$(findstring ios,$(platform)))
	cp out/bsnes_mercury_$(profile)_libretro_ios.dylib $(DESTDIR)$(core_installdir)/bsnes_mercury_$(profile)_libretro_ios.dylib
endif

uninstall:
ifeq ($(platform),linux)
	rm $(DESTDIR)$(core_installdir)/bsnes_mercury_$(profile)_libretro.so
else ifeq ($(platform),bsd)
	rm $(DESTDIR)$(core_installdir)/bsnes_mercury_$(profile)_libretro.so
else ifeq ($(platform),macosx)
	rm $(DESTDIR)$(core_installdir)/bsnes_mercury_$(profile)_libretro.dylib
else ifneq (,$(findstring ios,$(platform)))
	rm $(DESTDIR)$(core_installdir)/bsnes_mercury_$(profile)_libretro_ios.dylib
endif

=== debian/changelog ===
libretro-bsnes-mercury (094+git20220807-8) unstable; urgency=medium

  * Team upload
  * Fix Kodi plugins buttonmap.xml location (Closes: #1034583)

 -- Jonathan McDowell <noodles@earth.li>  Thu, 11 May 2023 10:47:35 +0000

libretro-bsnes-mercury (094+git20220807-7) unstable; urgency=medium

  * Team upload
  * Correct Architecture on kodi-* packages to build on armel/armhf
    (Closes: #1034524)

 -- Jonathan McDowell <noodles@earth.li>  Wed, 19 Apr 2023 09:49:56 +0100

libretro-bsnes-mercury (094+git20220807-6) unstable; urgency=medium

  * Team upload
  * Don't build kodi-* packages on mips* as kodi isn't available there

 -- Jonathan McDowell <noodles@earth.li>  Sun, 05 Feb 2023 11:33:37 +0000

libretro-bsnes-mercury (094+git20220807-5) unstable; urgency=medium

  * Team upload
  * Fix kodi-game-libretro-bsnes-mercury-accuracy dependency
    (Closes: #1030309)

 -- Jonathan McDowell <noodles@earth.li>  Thu, 02 Feb 2023 18:49:15 +0000

libretro-bsnes-mercury (094+git20220807-4) unstable; urgency=medium

  * Team upload
  * Upload to unstable now kodi-game-libretro has been accepted

 -- Jonathan McDowell <noodles@earth.li>  Wed, 01 Feb 2023 20:25:05 +0000

libretro-bsnes-mercury (094+git20220807-3) experimental; urgency=medium

  * Team upload
  * Upload to experimental pending kodi-game-libretro being accepted from NEW.
  * Correct Kodi library names to include _libretro suffix

 -- Jonathan McDowell <noodles@earth.li>  Fri, 27 Jan 2023 10:47:55 +0000

libretro-bsnes-mercury (094+git20220807-2) experimental; urgency=medium

  * Team upload
  * Upload to experimental pending kodi-game-libretro being accepted from NEW.
  * Update Vcs-* links to new libretro subproject
  * Add support for kodi-libretro-game configuration
  * Bump Standards-Version to 4.6.2.

 -- Jonathan McDowell <noodles@earth.li>  Sun, 22 Jan 2023 15:19:22 +0000

libretro-bsnes-mercury (094+git20220807-1) unstable; urgency=medium

  * Team upload
  * New upstream snapshot
    * Refresh patches
    * Update for build system changes + drop dh-exec usage
    * Update debian/copyright

 -- Jonathan McDowell <noodles@earth.li>  Wed, 21 Dec 2022 19:52:32 +0000

libretro-bsnes-mercury (094+git20160126-3) unstable; urgency=medium

  * Team upload.

  [ Helmut Grohne ]
  * Non-maintainer upload.
  * Fix FTCBFS: Rename CXX to compiler. (Closes: #941325)

 -- Fabian Greffrath <fabian@debian.org>  Wed, 09 Oct 2019 20:54:35 +0200

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,10 @@
 Priority: optional
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Sérgio Benjamim <sergio_br2@yahoo.com.br>
-Build-Depends: debhelper-compat (= 12), dh-exec
-Standards-Version: 4.3.0
-Vcs-Git: https://salsa.debian.org/games-team/libretro-bsnes-mercury.git
-Vcs-Browser: https://salsa.debian.org/games-team/libretro-bsnes-mercury
+Build-Depends: debhelper-compat (= 13)
+Standards-Version: 4.6.2
+Vcs-Git: https://salsa.debian.org/games-team/libretro/libretro-bsnes-mercury.git
+Vcs-Browser: https://salsa.debian.org/games-team/libretro/libretro-bsnes-mercury
 Homepage: https://github.com/libretro/bsnes-mercury
 
 Package: libretro-bsnes-mercury-accuracy
@@ -69,3 +69,64 @@
  This package comes with the bsnes-mercury performance core, which provides
  faster emulation at the cost of reduced accuracy, including problems with some
  games.
+
+Package: kodi-game-libretro-bsnes-mercury-accuracy
+Architecture: any-amd64 any-arm64 any-arm any-i386 any-powerpc any-ppc64 any-ppc64el any-riscv64 any-s390x any-sparc64
+Multi-Arch: same
+Depends: kodi-game-libretro, libretro-bsnes-mercury-accuracy, ${misc:Depends}
+Description: Kodi integration for bsnes-mercury accuracy core
+ This package contains the appropriate Kodi configuration to allow the use of
+ the bsnes-mercury accuracy libretro core with Kodi via kodi-game-libretro.
+ .
+ This core is enabled to emulate only SNES hardware and its subsystems (from
+ the command line only), like Super Game Boy, Satellaview and Sufami Turbo.
+ .
+ bsnes-mercury is a fork of higan, aiming to restore some useful features that
+ have been removed, as well as improving performance a bit. Maximum accuracy is
+ still uncompromisable; anything that affects accuracy is optional and off by
+ default. The name is because metals are shiny, like the accuracy promises of
+ bsnes, and mercury is the fastest metal.
+ .
+ This package pulls in the bsnes-mercury accuracy core, which runs 100% of SNES
+ games, with perfect emulation of the console. It requires high CPU usage.
+
+Package: kodi-game-libretro-bsnes-mercury-balanced
+Architecture: any-amd64 any-arm64 any-arm any-i386 any-powerpc any-ppc64 any-ppc64el any-riscv64 any-s390x any-sparc64
+Multi-Arch: same
+Depends: kodi-game-libretro, libretro-bsnes-mercury-balanced, ${misc:Depends}
+Description: Kodi integration for bsnes-mercury balanced core
+ This package contains the appropriate Kodi configuration to allow the use of
+ the bsnes-mercury balanced libretro core with Kodi via kodi-game-libretro.
+ .
+ This core is enabled to emulate only SNES hardware and its subsystems (from
+ the command line only), like Super Game Boy, Satellaview and Sufami Turbo.
+ .
+ bsnes-mercury is a fork of higan, aiming to restore some useful features that
+ have been removed, as well as improving performance a bit. Maximum accuracy is
+ still uncompromisable; anything that affects accuracy is optional and off by
+ default. The name is because metals are shiny, like the accuracy promises of
+ bsnes, and mercury is the fastest metal.
+ .
+ This package pulls in the bsnes-mercury balanced core, which tries to keep  a
+ good balance between accuracy and performance. It runs almost all SNES games.
+
+Package: kodi-game-libretro-bsnes-mercury-performance
+Architecture: any-amd64 any-arm64 any-arm any-i386 any-powerpc any-ppc64 any-ppc64el any-riscv64 any-s390x any-sparc64
+Multi-Arch: same
+Depends: kodi-game-libretro, libretro-bsnes-mercury-performance, ${misc:Depends}
+Description: Kodi integration for bsnes-mercury performance core
+ This package contains the appropriate Kodi configuration to allow the use of
+ the bsnes-mercury performance libretro core with Kodi via kodi-game-libretro.
+ .
+ This core is enabled to emulate only SNES hardware and its subsystems (from
+ the command line only), like Super Game Boy, Satellaview and Sufami Turbo.
+ .
+ bsnes-mercury is a fork of higan, aiming to restore some useful features that
+ have been removed, as well as improving performance a bit. Maximum accuracy is
+ still uncompromisable; anything that affects accuracy is optional and off by
+ default. The name is because metals are shiny, like the accuracy promises of
+ bsnes, and mercury is the fastest metal.
+ .
+ This package pulls in the bsnes-mercury performance core, which provides
+ faster emulation at the cost of reduced accuracy, including problems with some
+ games.

=== debian/rules ===
--- 
+++ 
@@ -15,9 +15,11 @@
 	dh $@
 
 override_dh_auto_build:
-	dh_auto_build -- profile=accuracy ui=target-libretro $(ARM)
-	dh_auto_build -- profile=balanced ui=target-libretro $(ARM)
-	dh_auto_build -- profile=performance ui=target-libretro $(ARM)
+	dh_auto_build -- PROFILE=accuracy ui=target-libretro compiler='$$(CXX)' $(ARM)
+	find . -name *.o -delete
+	dh_auto_build -- PROFILE=balanced ui=target-libretro compiler='$$(CXX)' $(ARM)
+	find . -name *.o -delete
+	dh_auto_build -- PROFILE=performance ui=target-libretro compiler='$$(CXX)' $(ARM)
 
 override_dh_auto_test:
